/*
 * Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
 */

/*
 * Fixes an object to the top of the page when the browser tries to scroll it off the page.
 */
HeaderFixer = function() {

  var fixedHeader = $('.pipeline-header-row');
  var floatingHeader = $('<table class="vertical-floating"></table>')
    .append(fixedHeader.clone())
    .prependTo('.pipeline-table-container');

  var currentWindow = $(window);
  var pageHeaders = $('#ctf-header-container');

  /*
   * Callback for fixing the table header to the top of the screen when the page is scrolled.
   */
  this.updateTableHeaders = function() {
    var offset = fixedHeader.offset(),
        scrollTop = currentWindow.scrollTop(),
        scrollLeft = currentWindow.scrollLeft(),
        show = (scrollTop > offset.top);

    floatingHeader
        .toggle(show);

    fixedHeader.toggleClass('under', show);

    pageHeaders.css('left', scrollLeft);
  };

  /*
   * Sets the window's scroll listener to update our table header.
   */
  this.addScrollListener = function() {
    currentWindow.scroll(this.updateTableHeaders);
  };

};
