#
# Copyright 2015 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

class Api::V1::TrackersController < Api::BaseController
  #Authenticates API calls with TeamForge
  include CtfApiAuthentication

  before_action :authenticate_with_teamforge_and_get_permissions
  before_action :require_crud_tracker
  before_action :get_project
  before_action :get_list_work_item_source_ids

  def index
    render json: Tracker.where(:work_item_source_id => @work_item_source_ids).to_a
  end

  def by_tracker_id
    if tracker = Tracker.where(:remote_id => params['tracker_id'], :work_item_source_id.ne => nil).first
      if @work_item_source_ids.include?(tracker.work_item_source_id)
        render json: tracker, status: :ok
      else
        head :not_found
      end
    else
      head :not_found
    end
  end


  private

  # Return the array with work item source ids for the current project
  def get_list_work_item_source_ids
    @work_item_source_ids = current_project.work_item_sources.map(&:id)
  end
end
