#
# Copyright 2015 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

class Api::V2::ReportsController < Api::V1::ReportsController 
  # Preprocess the query results.
  #
  # @param [DecoratedPluckyQuery] query_results Query results
  # @param [String] version API version string.
  # @return [Hash] Query results suitable for rendering as json.
  def processed_results(query_results, version)
    metadata_set = add_metadata_to_results(query_results)
    result_set = { items: query_results }
    [:source_display_data, :work_item_urls].each do |key|
      result_set[key] = metadata_set[key] unless metadata_set[key].empty?
    end
    result_set
  end


end
