#
# Copyright 2015 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

class Api::V3::SourcesController < Api::V2::SourcesController

  def work_item_sources_by_tracker_ids

    tracker_ids = params['tracker_ids'].nil? ? [] : params['tracker_ids'].split(',')

    work_item_source_ids = Tracker.where(:remote_id => tracker_ids, :work_item_source_id.ne => nil).all.map(&:work_item_source_id).compact
    work_item_sources =  ActivitySource.by_project(current_project.id).by_type('WorkItemSource').where(_id: work_item_source_ids).all

    render json: { sources: work_item_sources }, status: :ok
  end

end
