#
# Copyright 2016 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#
class Api::V6::PermissionQueueInfoController < Api::BaseController

  #Authenticates API calls with TeamForge
  include CtfApiAuthentication

  before_action :authenticate_with_teamforge_and_get_permissions
  before_action :require_super_user

  def index

    rabbitmq_config = Rails.application.config.rabbitmq
    rabbitmq_server = UriUtils.new(rabbitmq_config['uri']).host_parts

    result = {
        queue_server: "#{rabbitmq_server[:scheme]}://#{rabbitmq_server[:host]}:#{rabbitmq_server[:port]}",
        queue_username: rabbitmq_config['permission_publisher'],
        queue_password: rabbitmq_config['permission_publisher_password']
    }

    render json: { queue_info: result }, status: :ok
  end

end
