#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

# Controller that gates commits based on WorkflowRules
class CommitGateController < ApplicationController
  skip_before_filter :authenticate_user!

  def can_commit
    commit_message = params[:commit_message]
    repository_uuid = params[:repository_uuid]
    committer = params[:committer]
    commit_server = CommitServer.where(uuid: repository_uuid).first

    # get the workflow rule for commits
    rule = WorkflowRule.where(collection_name: 'commits').first

    # 200 if satisfy rule
    head :ok and return if rule.try(:can_commit, commit_server, commit_message)

    # 403 if previous conditions fail
    render inline: rule.error_message, status: :forbidden
  end
end
