#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

# Handles loading resources based on their unique ID.
# Used by CTF to redirect short references to an activity into the details page for that activity.
class GoController < ApplicationController
  # Redirects the user to the correct resource based on the given :object_id,
  # if they are authorized to view that pipeline
  # TODO: Currently, we use pipeline permission name for authentication of project, permission name needs to change
  def redirect
    activity_summary = ActivitySummary.first(opaque_id: params[:id])
    raise MongoMapper::DocumentNotFound.new(t("errors.activity.not_found")) unless activity_summary
    project = activity_summary.source.project
    authorize! :pipeline_read, project
    redirect_to polymorphic_path(activity_summary, :project => project)
  end
end
