#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

# Records the status of the last access for servers (BuildServer, CommitServer, ReviewBoard) we poll.
class AccessStatus
  include MongoMapper::EmbeddedDocument

  key :last_access, Time
  key :last_success, Time
  key :last_error, Time
  key :last_error_message, String
  key :last_error_trace, Array

  def last_access_status
    last_success_time = last_success || Time.at(0)
    last_error_time = last_error || Time.at(0)

    if last_success_time > last_error_time
      :success
    else
      :failure
    end
  end
end