#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

class ActivityFilter::AssociationTrace < ActivityFilter::Base
  attr_accessor :query
  attr_writer :hide_indirect_commits, :association_depth
  
  validates_presence_of :query
  validates :association_depth, numericality: { only_integer: true,
                                                greater_than_or_equal_to: Node::MIN_DEPTH,
                                                less_than_or_equal_to: Node::MAX_DEPTH }
  
  def association_depth
    @association_depth || Node::DEFAULT_DEPTH
  end
  
  def hide_indirect_commits
    !!@hide_indirect_commits
  end

   def node(project, activity, activities)
     options = {
       association_depth: association_depth,
       filter_commits:    hide_indirect_commits,
       start_date:        start ? start.to_time.beginning_of_day : nil,
       end_date:          self.end ? self.end.to_time.end_of_day : nil
     }
     Node.new(project, activity, activities, options)
   end
    
end