#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

# Represents an individual changed file in a review.
class ReviewedFile
  include MongoMapper::EmbeddedDocument

  key :file, String
  key :repository_url, String
  key :revision, String

  validates :file, presence: true

  # this object equals another if the principal fields are equal (ignoring Mongo id)
  def ==(other)
    [:file, :repository_url, :revision].inject(true) do |equality, n|
      equality && (self.attributes[n] == other.attributes[n])
    end
  end
end
