#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

# Represents a user permission
class UserPermission
  include MongoMapper::EmbeddedDocument

  #ToDo: Rename the permissions once changed in CTF
  PERMISSIONS = %w(pipeline_create pipeline_edit pipeline_read reporting_api pipeline_api pipeline_trusted_association)

  embedded_in :user
  belongs_to :project

  key :name, String, required: true

  validates :name, inclusion: { in: PERMISSIONS }
  validates_presence_of :project
end
