#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

module WorkItemStatus
  # @return [String] String representing the displayable status for a WorkItem, or 'unknown'
  def display_status

    if !remote_status_id
      'unknown'
    else
      tracker = Tracker.where('statuses.remote_id' => remote_status_id, 'work_item_source_id' => source_id).first
      found_status = tracker.statuses.detect {|s| s.remote_id == remote_status_id} if tracker
      found_status ? found_status.name.downcase : 'unknown'
    end
  end
end
