module V6
  class CustomActivitySourceSerializer < V5::CustomActivitySourceSerializer
    def serialize(options = {})
      if object.errors.empty?
        super.merge({
                        associated_activity_source_id: object.activity_source && object.activity_source.id,
                        activity_source_tag_names: object.activity_source_tags.map(&:name),
                        background_color_value: object.background_color_value,
                        icon_uri: object.icon_uri,
                        custom_schema_store_id: object.custom_schema_store_id,
                        trusted_sources: object.trusted_sources
                    })
      else
        ActivitySourceSerializer.substitute_keys(object.errors.messages, CustomActivitySource.nativized_keys.invert)
      end
    end
  end
end