module V6
  class WorkItemSourceSerializer < V5::WorkItemSourceSerializer

    def serialize(options = {})
      queue_server = ActivitySourceSerializer.queue_server
      if object.errors.empty?
        data = {
            id: object.id,
            _type:  MONGO_TO_API_SOURCE_TYPE_MAP[object._type],
            tool_id: object.tool_id,
            active: object.active,
            display_name: object.display_name,
            queue_username: object.queue_username,
            queue_password: object.queue_password,
            queue_server: queue_server,
            source_association_key: object.source_association_key,
        }
        # Additionally include tracker status mapping data for work items sources (where applicable)
        if (object.respond_to?(:tracker) && object.tracker)
          data[:status_map] = {}
          object.tracker.statuses.each { |h| data[:status_map][h.remote_id] = h.name }
        end
        data
      else
        object.errors.messages
      end
    end

  end
end