#############################################################################################
# Servicelog: writes log entries to a service log.
# In addition maintains a stack trace in stack_trace.log
#
# copyright collabnet, 2015
#############################################################################################

  class ServiceLog

    ##################################################
    # add an entry to the service log.
    # truncate the log if it is too big
    ##################################################

    def self.log(log_message)

      # Use the Rails logger instead of the service logger
      if Rails.application.config.SERVICE_LOG == false
        Rails.logger.error(log_message)
      end


      return if Rails.application.config.SERVICE_LOG.blank?
      time = Time.now.strftime("[%H:%M:%S] - ")
      log_message = time + log_message + "\n"

      # truncate a large log file
      if File.exist?("#{Rails.root}/log/service_log.log")
        fstat = File.stat("#{Rails.root}/log/service_log.log")
        if fstat.size > 100000
          File.open("#{Rails.root}/log/service_log.log", 'w') { |f| f.write '' }
        end
      end

      # write message to log
      File.open("#{Rails.root}/log/service_log.log", 'a') { |f| f.write log_message }

    end

    ##################################################
    # write the stack trace
    ##################################################

    def self.stack_trace(waypoint)

      if Rails.application.config.SERVICE_LOG == false
        return
      end

      waypoint += "\n"

      # truncate a large log file
      if File.exist?("#{Rails.root}/log/stack_trace.log")
        fstat = File.stat("#{Rails.root}/log/stack_trace.log")
        if fstat.size > 20000
          File.open("#{Rails.root}/log/stack_trace.log", 'w') { |f| f.write '' }
        end
      end

      # write the waypoint to the stack trace log
      File.open("#{Rails.root}/log/stack_trace.log", 'a') { |f| f.write waypoint }

    end

  end
