# Load the rails application
require File.expand_path('../application', __FILE__)

# Initialize the rails application
Orchestrate::Application.initialize!

# Monkey-patches the logger with a better format.
class Logger
  def format_message(severity, timestamp, progname, msg)
    "#{timestamp} (#{$$}) #{severity} #{msg}\n"
  end
end

if defined?(PhusionPassenger)
  PhusionPassenger.on_event(:starting_worker_process) do |forked|
    # We're in smart spawning mode.
    if forked
      #           # Re-establish redis connection
      Resque.redis.client.reconnect
    end
  end
end
