#
# Copyright 2015 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#
require 'migrations/exceptions'
class UpdateTheUrlFieldForCommitSummaries < Migration

  extend MigrationHelper

  CTF_GO_URL = CtfGoLinks.base_go_url

  def self.up
    self.create_urls_for_ctf_commit_summaries
  end

  def self.down
    self.remove_created_urls_for_ctf_commit_summaries
  end

  def self.create_urls_for_ctf_commit_summaries
    commit_summaries_only = {_type: 'CommitSummary'}
    iterate_over(:activity_summaries, commit_summaries_only) do |summary|
      unless summary['ctf_item'].nil?
        url_to_ctf_object = CTF_GO_URL + summary['ctf_item']['ctf_id']
        db[:activity_summaries].update({'_id' => summary['_id']}, {'$set' => {'ctf_commit_url' => url_to_ctf_object} })
      end
    end
  end

  def self.remove_created_urls_for_ctf_commit_summaries
    commit_summaries_only = {_type: 'CommitSummary'}
    iterate_over(:activity_summaries, commit_summaries_only) do |summary|
      unless summary['ctf_item'].nil?
        db[:activity_summaries].update({'_id' => summary['_id']}, {'$unset' => {'ctf_commit_url' => ''} })
      end
    end
  end

end