#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

class AccessLogUpdater

  # Updates the access status for the given activity source.
  # If a message is given, an error is logged.
  # @param activity_source the source
  # @param [String] error_message (optional) error message to add to the log
  def self.update_log(activity_source, error_message = nil)
    access_status = activity_source.access_status || AccessStatus.new
    access_time = Time.now
    if error_message
      access_status.last_error = access_time
      access_status.last_error_message = error_message
    else
      access_status.last_success = access_time
    end
    access_status.last_access = access_time
    activity_source.set("access_status" => access_status.to_mongo)
    activity_source.access_status = access_status
  end

end