# Base to all CN installations
COLLABNET_DIR         = File.join('/opt', 'collabnet')
RUBY_HOME_DIR         = File.join(COLLABNET_DIR, 'ruby')

# Name, product name, and URI prefix for this app:
APP_NAME              = 'eventq'
APP_PRODUCT_NAME      = 'EventQ'
APP_RELATIVE_URL_ROOT = '/orc'
APP_PACKAGE_NAME      = "CN-#{APP_NAME}"
APP_HOME_DIR          = File.join(COLLABNET_DIR, APP_NAME)

APP_DEFAULTS_YAML_FILE = File.join(APP_HOME_DIR, 'config', 'defaults.yml')
APP_SITE_OPTIONS_FILE  = File.join(APP_HOME_DIR, 'config', 'site-options.conf')
APP_LOCAL_OPTIONS_FILE = File.join(APP_HOME_DIR, 'config', 'templates', 'site-options-local.conf')

# Sets the base name used by all rabbit queues:
APP_BASE_QUEUE_NAME    = 'eventq'

# Backward compatibility - all messages will be published to old queues which will be shoveled into new queues.
OLD_APP_BASE_QUEUE_NAME    = 'orchestrate'

# Event Hub which is used to publish a message into multiple queues. This is needed for DevOps.
EVENT_HUB_NAME = 'event.hub'

# Names of all the individual rabbit queues:
BUILD_QUEUE_NAME                = "#{APP_BASE_QUEUE_NAME}.builds"
CUSTOM_QUEUE_NAME               = "#{APP_BASE_QUEUE_NAME}.custom"
REVIEW_QUEUE_NAME               = "#{APP_BASE_QUEUE_NAME}.reviews"
COMMIT_QUEUE_NAME               = "#{APP_BASE_QUEUE_NAME}.commits"
WORKITEM_QUEUE_NAME             = "#{APP_BASE_QUEUE_NAME}.work_items"
CTFUSERPERMISSION_QUEUE_NAME    = "#{APP_BASE_QUEUE_NAME}.ctf_user_permissions"

# Name of the application database in mongodb:
MONGODB_APP_DB_NAME    = 'orchestrate'

# Name of the application as its IAF representation:
APP_CTF_PLUG_NAME      = 'EventQ'

# System directories:
SYSTEM_INITD_DIR       = File.join('/etc', 'init.d')
SYSTEM_LOGROTATE_DIR   = File.join('/etc', 'logrotate.d')

# Nginx section:
NGINX_HOME_DIR         = File.join(COLLABNET_DIR, 'nginx')
NGINX_CONFIG_TEMPLATE  = File.join(APP_HOME_DIR, 'config', 'templates', 'nginx', 'nginx.conf.erb')
NGINX_CONFIG_FILE      = File.join(NGINX_HOME_DIR, 'conf', 'collabnet-nginx.conf')
NGINX_USER             = 'collabnet-nginx'
