#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

# this allows to use a Rails generator to create migration files.
# see USAGE file for the description on how the generator is invoked
class MigrationGenerator < Rails::Generators::NamedBase
  include Rails::Generators::Migration

  source_root File.expand_path('../templates', __FILE__)

  # this created a migration version (timestamp) which is prepended to the migration file name
  def self.next_migration_number(dirname)
    Time.now.utc.strftime("%Y%m%d%H%M%S")
  end

  # renders the template and puts the result into the migration file
  def create_migration_file
    migration_template("migration.erb", "db/migrations/#{file_name}.rb")
  end
end
