#
# Copyright 2016 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

require 'savon'
require File.expand_path("../../application_constants", __FILE__)

DEBUG = false

# TODO: where applicable and reasonable, move constants out of here (which is
# used by the installer alone) up into application_constants.rb (where it can be
# shared by the system as a whole).

# The installer uses this, in order, so be careful how you insert things
APP_ROLE = APP_NAME.to_sym
VALID_ROLES = [:rabbitmq, :mongodb, :nginx, APP_ROLE]
GENERATED_PASSWORD_LENGTH = 32

TEAMFORGE_APP_NAME = 'TeamForge'

APP_INSTALLER_ROOT_SSH_KEY_FILE = File.expand_path("~/.ssh/#{APP_NAME}_installer")
APP_INSTALLER_ROOT_PUBKEY_FILE = File.expand_path("~/.ssh/#{APP_NAME}_installer.pub")
APP_INSTALLER_AUTHORIZED_KEYS_FILE = File.expand_path("~/.ssh/authorized_keys")

APP_USER = APP_NAME 
FULL_PRODUCT_NAME = "#{TEAMFORGE_APP_NAME} #{APP_PRODUCT_NAME}"
APP_SERVICES_USER = APP_NAME
APP_TMP_SECRET_TOKEN = '/tmp/secret_token.rb'
APP_SERVICE_PORT = '8844'

# Base directory containing all of the installer's generated config files, marker files, and site options:
INSTALLER_BASE_DIR = File.join(APP_HOME_DIR, 'tmp', 'installer')
# Path to the config file use as mechanisms for the capistrano module to read
# information gathered during the frontend questions/answers:
INSTALLER_YAML_CONFIG_FILE = File.join(INSTALLER_BASE_DIR, 'installer.yml')
# Path to location of installer state markers:
INSTALLER_MARKER_DIR = File.join(INSTALLER_BASE_DIR, 'installer_tasks')
# Path to the generated site options file, representing the values from the last run of the installer:
INSTALLER_LAST_OPTIONS_FILE = File.join(INSTALLER_BASE_DIR, 'last-site-options.conf')

BACKUP_TIMESTAMP_FORMAT = '%Y%d%m%H%M%S'

# RabbitMQ section
RABBITMQ_HOME_DIR = File.join(COLLABNET_DIR, 'rabbitmq')
RABBITMQ_PASSWORDS_FILE = File.join(RABBITMQ_HOME_DIR, '.rabbit_passwords')
RABBITMQ_USER = 'collabnet-rabbitmq'
RABBITMQ_ADMIN = 'guest'
RABBITMQ_PERMISSION_PUBLISHER = 'permission_publisher'

# MongoDB
MONGODB_HOME_DIR = File.join(COLLABNET_DIR, 'mongodb')
MONGODB_PASSWORDS_FILE = File.join(MONGODB_HOME_DIR, '.mongo_passwords')
MONGODB_USER = 'collabnet-mongodb'
MONGODB_ADMIN_DB_NAME = 'admin'
MONGODB_ADMIN_DB_USER = 'admin'
MONGODB_BACKUP_DB_USER = 'backup'
#MONGODB_APP_DB_NAME comes from application constants.

#Sets logging level for Savon
#TODO - Ask EP why they are set
Savon.configure do |config|
  config.log = false
  config.log_level = :error
  config.logger = false
end

#Sets logging level for HTTPI
HTTPI.logger = false
HTTPI.log_level = :error
HTTPI.log = false
