#
# Copyright 2016 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

default_run_options[:pty] = true

namespace APP_ROLE do
  before "#{APP_NAME}:rabbitmq:install", "validate"
  before "#{APP_NAME}:rabbitmq:upgrade", "validate"
  before "#{APP_NAME}:rabbitmq:clean_reinstall", "validate"

  before "#{APP_NAME}:mongodb:install", "validate"
  before "#{APP_NAME}:mongodb:upgrade", "validate"
  before "#{APP_NAME}:mongodb:clean_reinstall", "validate"

  before "#{APP_NAME}:nginx:install", "validate"
  before "#{APP_NAME}:nginx:upgrade", "validate"
  before "#{APP_NAME}:nginx:clean_reinstall", "validate"

  before "#{APP_NAME}:#{APP_NAME}:install", "validate"
  before "#{APP_NAME}:#{APP_NAME}:upgrade", "validate"
  before "#{APP_NAME}:#{APP_NAME}:clean_reinstall", "validate"
  before "#{APP_NAME}:#{APP_NAME}:check_prefix_availability", "validate"
end

task :validate do
  installer.load_installer_yaml_config(INSTALLER_YAML_CONFIG_FILE)
  installer.validate_role
  installer.validate_ssh_hosts
  installer.validate_ssh_user
  installer.validate_credentials

  # validation is now good so setting role and server
  role fetch(:role), fetch(:ssh_hosts)
end

#Add /sbin to capistrano's ssh path for chkconfig and runuser
set :default_environment, {
    'PATH' => "/sbin:$PATH"
}
