#
# Copyright 2016 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

namespace APP_ROLE do
  namespace APP_ROLE do

    desc "Install #{APP_PRODUCT_NAME} app server"
    task :install, :roles => APP_ROLE do
      app_server.setup(:install)
    end

    desc "ReInstall #{APP_PRODUCT_NAME} app server"
    task :clean_reinstall, :roles => APP_ROLE do
      app_server.stop
      app_server.setup(:clean_reinstall)
    end


    desc "Upgrade the RPM packages for #{APP_PRODUCT_NAME}"
    task :upgrade, :roles => APP_ROLE do
      app_server.stop
      yum.update(APP_PACKAGE_NAME)
      app_server.start
    end

    desc "Check for #{APP_PRODUCT_NAME} prefixes in TeamForge"
    task :check_prefix_availability do
      app_server.validate
    end
  end
end
