#
# Copyright 2016 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

namespace APP_ROLE do
  namespace :mongodb do

    desc 'Install MongoDB'
    task :install, roles => :mongodb do
      yum.install('collabnet-mongodb')
      mongo.setup
    end

    desc 'Upgrade the RPM package for MongoDB'
    task :upgrade, roles => :mongodb do
      mongo.stop
      yum.install('collabnet-mongodb')
      mongo.start
    end

    desc 'Reinstall MongoDB from scratch, saves a copy of previous data'
    task :clean_reinstall, roles => :mongodb do
      mongo.stop
      mongo.backup_data
      yum.install('collabnet-mongodb')
      mongo.setup
    end

    desc 'Test connection to MongoDB'
    task :test_connection, roles => :mongodb do
      mongo.verify_connection
    end

  end
end
