#
# Copyright 2016 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

namespace APP_ROLE do
  namespace :nginx do
    desc "Install Nginx"
    task :install, :roles => :nginx do
      yum.install('collabnet-nginx')
      nginx_plugin.setup
    end

    desc "Upgrade the RPM package for Nginx"
    task :upgrade, :roles => :nginx do
      nginx_plugin.stop
      yum.update('collabnet-nginx')
      nginx_plugin.start
    end

    desc "Reinstall nginx"
    task :clean_reinstall, :roles => :nginx do
      nginx_plugin.stop
      nginx_plugin.setup
    end
  end
end
