#
# Copyright 2016 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

namespace APP_NAME.to_sym do
  namespace :rabbitmq do
    desc "Install RabbitMQ"
    task :install, :roles => :rabbitmq do
      yum.install('collabnet-rabbitmq')
      rabbit.setup
    end

    desc "Upgrade the RPM package for RabbitMQ"
    task :upgrade, :roles => :rabbitmq do
      rabbit.stop
      yum.install('collabnet-rabbitmq')
      rabbit.start
    end
    
    desc "Reinstall RabbitMQ from scratch with saving data folder"
    task :clean_reinstall, :roles => :rabbitmq do
      rabbit.stop
      rabbit.backup_data
      rabbit.setup
    end

    task :test_connection do
      rabbit.verify_connection
    end

  end
end
