#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

# this is mostly a straight ActiveRecord::Migration code.
class MigrationError < ::MongoMapper::Error; end

class IrreversibleMigration < MigrationError#:nodoc:
end

class DuplicateMigrationVersionError < MigrationError#:nodoc:
  def initialize(version)
    super("Multiple migrations have the version number #{version}")
  end
end

class DuplicateMigrationNameError < MigrationError#:nodoc:
  def initialize(name)
    super("Multiple migrations have the name #{name}")
  end
end

class UnknownMigrationVersionError < MigrationError #:nodoc:
  def initialize(version)
    super("No migration with version number #{version}")
  end
end

class IllegalMigrationNameError < MigrationError#:nodoc:
  def initialize(name)
    super("Illegal name for migration file: #{name}\n\t(only lower case letters, numbers, and '_' allowed)")
  end
end
