#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

# currently is included in ActivitySourceController and WorkItemIntegrationUtils
module RabbitServices
  # creates RabbitMq users (we use it when creating sources)
  def create_queue_account(username, password)
    if username && password
      rabbit_uri = rabbit_config['uri']
      uri = URI.parse(rabbit_uri)
      rabbit_admin = rabbit_config['admin_user'] || uri.user || 'guest'
      rabbit_password = rabbit_config['admin_password'] || uri.password || 'guest'
      queue_server = Rabbit::Management.new(rabbit_admin, rabbit_password, rabbit_uri)
      queue_server.logger = logger # note the the including class needs to implement #logger method
      queue_server.create_user(username, password) && queue_server.set_permissions(username)
    else
      # Pretend success if no username and password were provided.
      true
    end
  end


  private
  # loads rabbit configuration
  #
  def rabbit_config
    @rabbit_config ||= Rails.configuration.local_settings.load('rabbitmq')
  end

  def setup_config
    rabbit_config
    @forge_config = Rails.configuration.local_settings.load('teamforge')
    @orc_url = @forge_config && @forge_config['iaf'] && @forge_config['iaf']['orc_url']
  end
end
