require 'yaml'

# a task namespace to help support the application 
namespace :dev do
  desc "Setup #{APP_PRODUCT_NAME}"
  task :setup => :environment do

    puts "Setting Indexes"
    Rake::Task["db:index"].invoke

    puts "Running Migrations"
    Rake::Task["db:migrate"].invoke
   
    puts "Registering site wide linked app"
    linked_app_id = CtfConfigurer.new.create_site_wide_linked_application
    config_file = 'config/user/vagrant.yml'
    user_config = YAML.load_file config_file
    user_config['teamforge']['development']['linked_app_id'] = linked_app_id.to_s
    File.open(config_file, 'w') { |file| file.write user_config.to_yaml}
 
    puts "Please start #{APP_PRODUCT_NAME} with 'sudo systemctl start #{APP_NAME}.target'"
    puts "And then run 'bundle exec rake dev:register' to register IAF from #{APP_PRODUCT_NAME} to teamforge"
  end

  desc "Register #{APP_PRODUCT_NAME} IAF with teamforge"
  task :register => :environment do

    raise "#{APP_PRODUCT_NAME} is not started, aborting registration" unless File.exists? 'tmp/pids/server.pid'

    puts "Registering IAF..."
    CtfConfigurer.new.create_iaf_application

  end
end
