# a task namespace for support tasks.
namespace :support do
  desc 'Resolves orphaned activities'
  task :resolve_orphan_activities => :environment do

    # Orphan activities are ones which do not have a summary parent
    orphans = Activity.where(activity_summary_id: nil)

    puts "Finding homes for #{orphans.count} orphan activities" unless Rails.env == 'test'
    orphans.each do |orphan|
      summary_type = ActivitySummary.summary_type_from_source(orphan.source) if orphan.try(:source).try(:project)
      summary_type.create_or_update(orphan) if summary_type
    end

    puts "Complete!" unless Rails.env == 'test'
  end


end
