#
# Copyright 2014 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

# Validation processing
module Verifiable

  # Checks for required fields in the given hash
  # @param [Hash] req hash containing the fields to check
  # @param [Array] required_fields an array of fields to check against, can contain sub arrays
  # @return true if all required fields are present, false otherwise
  def check_data(req, required_fields = REQUIRED)
    required_fields.each do |field|
      check_key = field
      check_key = field.first if field.respond_to? :first

      return false unless req.include? check_key
      if field.is_a? Array
        return false unless check_data(req[check_key], field.last)
      end
    end

    true
  end
end
