require 'erb'
require 'ostruct'

module OmniAuth::Strategies::Teamforge::Fixtures
  # Load a fixture, process it through ERB, and return the resultant string.
  def fixture(name, locals = {})
    file = File.join(File.dirname(__FILE__), '..', '..', 'fixtures', "#{name}.xml.erb")

    raise "No such file #{file}" unless File.exist?(file)

    template = File.open(file) { |f| f.read }
    ERB.new(template).result(OpenStruct.new(locals).instance_eval {binding})
  end
end
