#
# Copyright 2016 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#
require 'migrations/exceptions'
include RabbitServices

class GenerateQueueInfoToCtfCommitSources < Migration

  extend MigrationHelper

  def self.up
    ctf_commit_sources = CtfRepository.where(:to_delete => [false, nil]).all
    ctf_commit_sources.each do | ccs |
      begin
        if ccs.source_association_key
          queue_username = ccs.queue_username || ccs.source_association_key
          queue_password = ccs.queue_password || SecureRandom.hex(32).to_s
          ccs.update_attribute(:queue_username, queue_username)
          ccs.update_attribute(:queue_password, queue_password)
          create_queue_account(queue_username, queue_password)
        end
      rescue => e
        logger.debug("Error found: #{e.inspect}")
      end
    end
  end
end