#
# Copyright 2016 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

class CtfInterpolations

  CTF_BASE_URL = Rails.configuration.teamforge[:server]
  CTF_GO_URL   = URI.join(CTF_BASE_URL, "/sf/go").to_s

  # Interpolate all the ctf tokens found in a string to their runtime values.
  #
  # @param [String] text String to search for tokens
  # @return [String] Interpolated text.
  def self.interpolate_ctf_tokens(text)
    result = text.to_s
    result.gsub!('%CTF_BASE_URL%', CTF_BASE_URL)
    result.gsub!('%CTF_GO_URL%',   CTF_GO_URL)
    result
  end

end
