#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#
# this class handles soap calls to the CTF's OrchestrateSyncListener endpoint

class OrchestrateSyncListenerService
  @queue = :ctf_association_job

  def initialize
    @service = CtfService.create_authenticated_teamforge_session.sync
  end

  # triggers sending a world state message by CTF for a given project
  def send_world_state_message(project_id)
    @service.send_world_state_message(project_id: project_id)
  end

  def self.perform(project_id)
    self.new.send_world_state_message(project_id)
  end
end