class WorkItemIntegrationUtils

  def logger
    Rails.logger
  end

  # for upgraded version of application will schedule a Resque job to create ctf tracker sources for ctf projects that
  # don't have one.
  class Upgrader
    @queue = :ctf_association_job

    def self.perform
      CtfConfigurer.new.edit_iaf_application
      TeamForge::ProjectConfiguration.where(tracker_source_id: nil).each do |project_configuration|
          WorkItemIntegrationUtils.new.create_tracker_source(project_configuration)
      end
    end
  end
end
